diff --git a/charts/keycloak-operator/templates/keycloak-operator-deployment.yaml b/charts/keycloak-operator/templates/keycloak-operator-deployment.yaml
index a0860ab..783f40c 100644
--- a/charts/keycloak-operator/templates/keycloak-operator-deployment.yaml
+++ b/charts/keycloak-operator/templates/keycloak-operator-deployment.yaml
@@ -31,10 +31,17 @@ spec:
         - name: {{ .Chart.Name }}
           image: "{{ .Values.image.repository }}:{{ .Values.image.tag | default .Chart.AppVersion }}"
           env:             
+            {{- with .Values.watchNamespaces }}
+            - name: QUARKUS_OPERATOR_SDK_CONTROLLERS_KEYCLOAKCONTROLLER_NAMESPACES
+              value: {{ join "," .  }}
+            - name: QUARKUS_OPERATOR_SDK_CONTROLLERS_KEYCLOAKREALMIMPORTCONTROLLER_NAMESPACES
+              value: {{ join "," .  }}
+            {{- else }}
             - name: KUBERNETES_NAMESPACE
               valueFrom: 
                 fieldRef: 
                   fieldPath: metadata.namespace
+            {{- end }}
             - name: RELATED_IMAGE_KEYCLOAK
               value: "{{ .Values.keycloakImage.repository }}:{{ .Values.keycloakImage.tag | default .Chart.AppVersion }}"
           imagePullPolicy: {{ .Values.image.pullPolicy }}
diff --git a/charts/keycloak-operator/templates/keycloak-operator-role-binding-rb.yaml b/charts/keycloak-operator/templates/keycloak-operator-role-binding-rb.yaml
index a2cb2b2..011c38a 100644
--- a/charts/keycloak-operator/templates/keycloak-operator-role-binding-rb.yaml
+++ b/charts/keycloak-operator/templates/keycloak-operator-role-binding-rb.yaml
@@ -1,14 +1,22 @@
-# Generated by [Kustohelmize](https://github.com/yeahdongcn/kustohelmize)
+{{- range  .Release.Namespace | append .Values.watchNamespaces | uniq }}
+---
 apiVersion: rbac.authorization.k8s.io/v1
 kind: RoleBinding
 metadata: 
   name: keycloak-operator-role-binding
+  {{- if ne . $.Release.Namespace }}
+  namespace: {{ . }}
+  {{- end }}
   labels:
-    {{- include "keycloak-operator.labels" . | nindent 4 }}
+    {{- include "keycloak-operator.labels" $ | nindent 4 }}
 roleRef: 
   kind: Role
   apiGroup: rbac.authorization.k8s.io
   name: keycloak-operator-role
 subjects:   
   - kind: ServiceAccount
-    name: {{ include "keycloak-operator.serviceAccountName" . }}
+    name: {{ include "keycloak-operator.serviceAccountName" $ }}
+    {{- if ne . $.Release.Namespace }}
+    namespace: {{ $.Release.Namespace }}
+    {{- end }}
+{{- end }}
diff --git a/charts/keycloak-operator/templates/keycloak-operator-role-role.yaml b/charts/keycloak-operator/templates/keycloak-operator-role-role.yaml
index b87221b..1a72259 100644
--- a/charts/keycloak-operator/templates/keycloak-operator-role-role.yaml
+++ b/charts/keycloak-operator/templates/keycloak-operator-role-role.yaml
@@ -1,8 +1,12 @@
-# Generated by [Kustohelmize](https://github.com/yeahdongcn/kustohelmize)
+{{- range  .Release.Namespace | append .Values.watchNamespaces | uniq }}
+---
 apiVersion: rbac.authorization.k8s.io/v1
 kind: Role
 metadata: 
   name: keycloak-operator-role
+  {{- if ne . $.Release.Namespace }}
+  namespace: {{ . }}
+  {{- end }}
 rules:   
   - apiGroups: 
       - apps
@@ -67,3 +71,4 @@ rules:
       - delete
       - patch
       - update
+{{- end }}
diff --git a/charts/keycloak-operator/templates/keycloak-operator-view-rb.yaml b/charts/keycloak-operator/templates/keycloak-operator-view-rb.yaml
index 75addba..6ccd05d 100644
--- a/charts/keycloak-operator/templates/keycloak-operator-view-rb.yaml
+++ b/charts/keycloak-operator/templates/keycloak-operator-view-rb.yaml
@@ -1,14 +1,22 @@
-# Generated by [Kustohelmize](https://github.com/yeahdongcn/kustohelmize)
+{{- range  .Release.Namespace | append .Values.watchNamespaces | uniq }}
+---
 apiVersion: rbac.authorization.k8s.io/v1
 kind: RoleBinding
 metadata: 
   name: keycloak-operator-view
+  {{- if ne . $.Release.Namespace }}
+  namespace: {{ . }}
+  {{- end }}
   labels:
-    {{- include "keycloak-operator.labels" . | nindent 4 }}
+    {{- include "keycloak-operator.labels" $ | nindent 4 }}
 roleRef: 
   kind: ClusterRole
   apiGroup: rbac.authorization.k8s.io
   name: view
 subjects:   
   - kind: ServiceAccount
-    name: {{ include "keycloak-operator.serviceAccountName" . }}
+    name: {{ include "keycloak-operator.serviceAccountName" $ }}
+    {{- if ne . $.Release.Namespace }}
+    namespace: {{ $.Release.Namespace }}
+    {{- end }}
+{{- end }}
diff --git a/charts/keycloak-operator/templates/keycloakcontroller-role-binding-rb.yaml b/charts/keycloak-operator/templates/keycloakcontroller-role-binding-rb.yaml
index cefa64f..d5b8329 100644
--- a/charts/keycloak-operator/templates/keycloakcontroller-role-binding-rb.yaml
+++ b/charts/keycloak-operator/templates/keycloakcontroller-role-binding-rb.yaml
@@ -1,12 +1,20 @@
-# Generated by [Kustohelmize](https://github.com/yeahdongcn/kustohelmize)
+{{- range  .Release.Namespace | append .Values.watchNamespaces | uniq }}
+---
 apiVersion: rbac.authorization.k8s.io/v1
 kind: RoleBinding
 metadata: 
   name: keycloakcontroller-role-binding
+  {{- if ne . $.Release.Namespace }}
+  namespace: {{ . }}
+  {{- end }}
 roleRef: 
   kind: ClusterRole
   apiGroup: rbac.authorization.k8s.io
   name: keycloakcontroller-cluster-role
 subjects:   
   - kind: ServiceAccount
-    name: {{ include "keycloak-operator.serviceAccountName" . }}
+    name: {{ include "keycloak-operator.serviceAccountName" $ }}
+    {{- if ne . $.Release.Namespace }}
+    namespace: {{ $.Release.Namespace }}
+    {{- end }}
+{{- end }}
diff --git a/charts/keycloak-operator/templates/keycloakrealmimportcontroller-role-binding-rb.yaml b/charts/keycloak-operator/templates/keycloakrealmimportcontroller-role-binding-rb.yaml
index 0538d27..c677a8b 100644
--- a/charts/keycloak-operator/templates/keycloakrealmimportcontroller-role-binding-rb.yaml
+++ b/charts/keycloak-operator/templates/keycloakrealmimportcontroller-role-binding-rb.yaml
@@ -1,12 +1,20 @@
-# Generated by [Kustohelmize](https://github.com/yeahdongcn/kustohelmize)
+{{- range  .Release.Namespace | append .Values.watchNamespaces | uniq }}
+---
 apiVersion: rbac.authorization.k8s.io/v1
 kind: RoleBinding
 metadata: 
   name: keycloakrealmimportcontroller-role-binding
+  {{- if ne . $.Release.Namespace }}
+  namespace: {{ . }}
+  {{- end }}
 roleRef: 
   kind: ClusterRole
   apiGroup: rbac.authorization.k8s.io
   name: keycloakrealmimportcontroller-cluster-role
 subjects:   
   - kind: ServiceAccount
-    name: {{ include "keycloak-operator.serviceAccountName" . }}
+    name: {{ include "keycloak-operator.serviceAccountName" $ }}
+    {{- if ne . $.Release.Namespace }}
+    namespace: {{ $.Release.Namespace }}
+    {{- end }}
+{{- end }}
